Index: trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/cdm/ClassifierManager.java	(revision 4595)
@@ -879,5 +879,7 @@
 		    }
 		    catch (Exception error) {
-			gatherer.debug(error, "Error in ClassifierManager.AddListener.actionPerformed(): " + error);
+			Gatherer.println("Error in ClassifierManager.AddListener.actionPerformed(): " + error);
+			Gatherer.printStackTrace(error);
+			
 		    }
 		    // And if all else fails create a new classifier.
Index: trunk/gli/src/org/greenstone/gatherer/cdm/CollectionDesignManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/cdm/CollectionDesignManager.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/cdm/CollectionDesignManager.java	(revision 4595)
@@ -343,5 +343,5 @@
 	    }
 	    in.close();
-				// Now attempt to finalize any commands that were not immediately parsed as they were waiting for unresolved references.
+	    // Now attempt to finalize any commands that were not immediately parsed as they were waiting for unresolved references.
 	    subcollections.reparseUnresolved();
 	    classifiers.reparseUnresolved();
@@ -366,5 +366,5 @@
     public void save() {
 	try {
-				// If the file already exists (it should) rename it.
+	    // If the file already exists (it should) rename it.
 	    if(in_file.exists()) {
 		String filename = in_file.getAbsolutePath();
@@ -372,5 +372,5 @@
 		backup.deleteOnExit();
 		if(!in_file.renameTo(backup)) {
-		    gatherer.debug("Error in CollectionDesignManager.parse(): FileRenamedException");
+		    Gatherer.println("Error in CollectionDesignManager.parse(): FileRenamedException");
 		}
 		in_file = new File(filename); // Just in case we moved it.
Index: trunk/gli/src/org/greenstone/gatherer/collection/SaveCollectionTask.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/collection/SaveCollectionTask.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/collection/SaveCollectionTask.java	(revision 4595)
@@ -133,5 +133,5 @@
 		backup.deleteOnExit();
 		if(!file.renameTo(backup)) {
-		    Gatherer.println("Error in CollectionManager.load(): FileNotRenamedException");
+		    Gatherer.println("Error in CollectionManager.load(): FileRenamedException");
 		}
 	    }
@@ -156,11 +156,11 @@
 	// Now we check whether we've finished, or is this a Save As action, in which case we've got miles to go.
 	if(name != null) {
-				// 2. Call CollectionManager.makeCollection() to create the collection structure to save into (copied collection).
-				///ystem.err.println("2. Make copy.");
+	    // 2. Call CollectionManager.makeCollection() to create the collection structure to save into (copied collection).
+	    ///ystem.err.println("2. Make copy.");
 	    Gatherer.c_man.createCollection(null, null, name, null, null, null);
 	    // spd.setProgress(getValue(MAKE_COLLECTION));
-				// 3. Copy files from the origin to the copied collections (except special collection files ending with ~).
-				// As part of this we must rename origin.col to copy.col
-				///ystem.err.println("3. Copy origin.");
+	    // 3. Copy files from the origin to the copied collections (except special collection files ending with ~).
+	    // As part of this we must rename origin.col to copy.col
+	    ///ystem.err.println("3. Copy origin.");
 	    ArrayList files = new ArrayList();
 	    File collection_file = new File(Gatherer.c_man.getCollectionFilename());
Index: trunk/gli/src/org/greenstone/gatherer/gui/GEditorPane.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/GEditorPane.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/gui/GEditorPane.java	(revision 4595)
@@ -259,5 +259,5 @@
     public void loadFile(File file) {
 	// Load the file.
-	gatherer.debug("Opening config file " + file.getAbsolutePath());
+	Gatherer.println("GEditorPane.loadFile():Opening config file " + file.getAbsolutePath());
 	try {
 	    FileInputStream in = new FileInputStream(file);
@@ -273,5 +273,5 @@
 	catch (Exception error) {
 	    //error.printStackTrace();
-	    gatherer.debug("Error: No Such File.");
+	    Gatherer.println("GEditorPane.loadFile():Error: No Such File.");
 	}
     }
Index: trunk/gli/src/org/greenstone/gatherer/gui/MetaEditPane.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/MetaEditPane.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/gui/MetaEditPane.java	(revision 4595)
@@ -436,9 +436,9 @@
 	  thumbnail_pane = new JPanel(new BorderLayout());
 
-	  gatherer.debug("\tCreating thumbnail_label");
+	  Gatherer.println("\tCreating thumbnail_label");
 	  thumbnail_label = new JLabel(get("Thumbnail"));
 	  thumbnail_label.setHorizontalAlignment(JLabel.CENTER);
 
-	  gatherer.debug("\tCreating thumbnail_view_pane");
+	  Gatherer.println("\tCreating thumbnail_view_pane");
 	  thumbnail_view_pane = new JPanel(new FlowLayout(FlowLayout.CENTER));
 	  thumbnail_scroll = new JScrollPane(thumbnail_view_pane);
Index: trunk/gli/src/org/greenstone/gatherer/gui/SaveProgressDialog.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/SaveProgressDialog.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/gui/SaveProgressDialog.java	(revision 4595)
@@ -113,5 +113,6 @@
 	}
 	catch (Exception e) {
-	    gatherer.debug(e, "Error in SaveProgressDialog.update(): " + e);
+	    Gatherer.println("Error in SaveProgressDialog.update(): " + e);
+	    Gatherer.printStackTrace(e);
 	}
     }
Index: trunk/gli/src/org/greenstone/gatherer/gui/browser/GHTMLPane.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/browser/GHTMLPane.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/gui/browser/GHTMLPane.java	(revision 4595)
@@ -109,5 +109,5 @@
 	forward_pages = new Vector(); 
 
-	gatherer.debug("\t\tCreating GHTMLPane");
+	Gatherer.println("\t\tCreating GHTMLPane");
 	view = new JEditorPane();
 	view.setEditable(false);
Index: trunk/gli/src/org/greenstone/gatherer/msm/GDMManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/msm/GDMManager.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/msm/GDMManager.java	(revision 4595)
@@ -147,5 +147,5 @@
 	    }
 	    put(metadata_file, metadata_xml);
-				//gatherer.debug(null, "[0ms]\tCached " + metadata_file);
+	    //Gatherer.println("[0ms]\tCached " + metadata_file);
 	}
 	return metadata_xml;
Index: trunk/gli/src/org/greenstone/gatherer/msm/MSMProfiler.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/msm/MSMProfiler.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/msm/MSMProfiler.java	(revision 4595)
@@ -215,5 +215,5 @@
 		backup.deleteOnExit();
 		if(!profile_file.renameTo(backup)) {
-		    Gatherer.println("Error in MSMProfiler.save(): FileRenameException");
+		    Gatherer.println("Error in MSMProfiler.save(): FileRenamedException");
 		}
 		backup = null;
Index: trunk/gli/src/org/greenstone/gatherer/msm/MetadataSetManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/msm/MetadataSetManager.java	(revision 4594)
+++ trunk/gli/src/org/greenstone/gatherer/msm/MetadataSetManager.java	(revision 4595)
@@ -914,5 +914,5 @@
 		backup.deleteOnExit();
 		if(!temp[i].renameTo(backup)) {
-		    Gatherer.println("Error in MetadataSetManager.save(): FileRenameException");
+		    Gatherer.println("Error in MetadataSetManager.save(): FileRenamedException");
 		}
 	    }