Index: trunk/gli/src/org/greenstone/gatherer/gui/table/GTableModel.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/gui/table/GTableModel.java	(revision 4626)
+++ trunk/gli/src/org/greenstone/gatherer/gui/table/GTableModel.java	(revision 4627)
@@ -409,27 +409,30 @@
 		for (int j = 0; j < metadata.size(); j++) {
 		    Metadata metadatum = (Metadata) metadata.get(j);
+		    ElementWrapper element = metadatum.getElement();
 		    // System.err.println("  Metadatum: " + metadatum + " (" + metadatum.getCount() + ")");
 
-		    // If a piece of metadata is at folder level, display the warning
-		    if (!metadatum.isFileLevel()) {
-			showInheritedMetadataWarning();
-		    }
-
-		    // If the piece of metadata is in the list, increment its count
-		    int index = current_metadata.indexOf(metadatum);
-		    if (index >= 0) {
-			Metadata existing = (Metadata) current_metadata.get(index);
-			existing.inc();
-		    }
-		    // Otherwise add it to the list
-		    else {
-			metadatum.setCount(1);
-			index = add(current_metadata, metadatum);
-			fireTableRowsInserted(index, index);
-
-			// Remember we have seen this element
-			ElementWrapper element = metadatum.getElement();
-			if (known_elements.contains(element) == false) {
-			    known_elements.add(element);
+		    // Ignore hidden metadata
+		    if (!element.toString().startsWith("hidden.")) {
+			// If a piece of metadata is at folder level, display the warning
+			if (!metadatum.isFileLevel()) {
+			    showInheritedMetadataWarning();
+			}
+
+			// If the piece of metadata is in the list, increment its count
+			int index = current_metadata.indexOf(metadatum);
+			if (index >= 0) {
+			    Metadata existing = (Metadata) current_metadata.get(index);
+			    existing.inc();
+			}
+			// Otherwise add it to the list
+			else {
+			    metadatum.setCount(1);
+			    index = add(current_metadata, metadatum);
+			    fireTableRowsInserted(index, index);
+
+			    // Remember we have seen this element
+			    if (known_elements.contains(element) == false) {
+				known_elements.add(element);
+			    }
 			}
 		    }
@@ -497,5 +500,4 @@
 	public void run() {
 	    if(Gatherer.c_man != null && Gatherer.c_man.ready()) {
-		System.err.println("Building metadata model...");
 		Vector elements = Gatherer.c_man.getCollection().msm.getElements();
 		// Show some visual indication that building is occuring.
@@ -510,11 +512,9 @@
 		for(int i = 0; i < file_nodes.length; i++) {
 		    File current_file = file_nodes[i].getFile();
-		    System.err.println("File: " + current_file);
+
 		    // The current assigned metadata for this file.
 		    ArrayList metadatum = Gatherer.c_man.getCollection().gdm.getAllMetadata(current_file);
-		    System.err.println("Pieces of metadata: " + metadatum.size());
 		    for(int j = 0; j < metadatum.size(); j++) {
 			Metadata data = (Metadata) metadatum.get(j);
-			System.err.println("  Metadata value: " + data);
 			// Determine the target list by the metadata level
 			ArrayList modified_metadata;
@@ -573,12 +573,11 @@
 		}
 				// Add entries for the currently unassigned metadata. You can determine these as the difference between elements and known_elements.
-		System.err.println("Number of elements: " + elements.size());
-		System.err.println("Number of known elements: " + known_elements.size());
+		// System.err.println("Number of elements: " + elements.size());
+		// System.err.println("Number of known elements: " + known_elements.size());
 		for(int k = 0; k < elements.size(); k++) {
 		    // For each key.
 		    ElementWrapper element = (ElementWrapper) elements.get(k);
-		    System.err.println("Element " + k + ": " + element);
+		    // System.err.println("Element " + k + ": " + element);
 		    if(!known_elements.contains(element)) {
-			System.err.println("(Doesn't contain)");
 			Metadata data = new Metadata(element);
 			int index = add(unassigned_metadata, data);
@@ -589,5 +588,5 @@
 			//else if(current_view == SHOW_ALL) {
 			if((index = current_metadata.indexOf(data)) == -1) {
-			    System.err.println("Adding " + data + " to " + current_metadata);
+			    // System.err.println("Adding " + data + " to " + current_metadata);
 			    index = add(current_metadata, data);
 			    fireTableRowsInserted(index, index);