Index: /trunk/gsdl3/INSTALL
===================================================================
--- /trunk/gsdl3/INSTALL	(revision 4847)
+++ /trunk/gsdl3/INSTALL	(revision 4848)
@@ -31,5 +31,5 @@
 To run tomcat, you need to have sourced setup.bash in $GSDL3HOME  to set up $CLASSPATH. Then, 
 
-cd \gsdlhome/comms/tomcat/jakarta-tomcat-4.0.1/bin
+cd $gsdlhome/comms/jakarta/tomcat/bin
 ./startup.sh
 
@@ -41,8 +41,8 @@
 Note: tomcat must be shutdown and restarted any time you make changes in the following for those changes to take effect:
 web/WEB-INF/web.xml
-comms/tomcat/jakarta-tomcat-4.0.1/conf/server.xml
+comms/jakarta/tomcat/conf/server.xml
 any classes or jar files used by the servlets
 
-Note: stdin and stdout for the servlets both go to comms/tomcat/jakarta/logs/catalina.out
+Note: stdin and stdout for the servlets both go to comms/jakarta/tomcat/logs/catalina.out
 
 SITES:
@@ -99,5 +99,5 @@
 address for talking to the tomcat SOAP servlet services.
 
-Note: you can change tomcat to use a different port if you like. Edit comms/tomcat/jakarta/conf/server.xml, and change 8080 to whatever. If you do this, and are using soap, you need to remember to change the port number in:
+Note: you can change tomcat to use a different port if you like. Edit comms/jakarta/tomcat/conf/server.xml, and change 8080 to whatever. If you do this, and are using soap, you need to remember to change the port number in:
 
 the install-soap.bash file where it tries to deploy site1.
Index: /trunk/gsdl3/install-nocvs.bash
===================================================================
--- /trunk/gsdl3/install-nocvs.bash	(revision 4847)
+++ /trunk/gsdl3/install-nocvs.bash	(revision 4848)
@@ -30,7 +30,7 @@
 
 # unpack tomcat and create symbolic link
-cd comms/tomcat/
+cd comms/jakaarta/
 tar xzf jakarta-tomcat-4.0.1.tar.gz 
-ln -s jakarta-tomcat-4.0.1 jakarta
+ln -s jakarta-tomcat-4.0.1 tomcat
 cd $GSDL3HOME
 
@@ -58,16 +58,16 @@
 
 #edit the catalina script
-cat  comms/tomcat/jakarta-tomcat-4.0.1/bin/catalina.sh | sed 's,CP=\"$CATALINA_HOME/bin/bootstrap.jar\",CP=\"$CLASSPATH:$CATALINA_HOME/bin/bootstrap.jar\",' > catalina.sh
-mv   comms/tomcat/jakarta/bin/catalina.sh comms/tomcat/jakarta/bin/catalina.bak.sh
-mv catalina.sh comms/tomcat/jakarta/bin/catalina.sh 
+cat  comms/jakarta/tomcat/bin/catalina.sh | sed 's,CP=\"$CATALINA_HOME/bin/bootstrap.jar\",CP=\"$CLASSPATH:$CATALINA_HOME/bin/bootstrap.jar\",' > catalina.sh
+mv   comms/jakarta/tomcat/bin/catalina.sh comms/jakarta/tomcat/bin/catalina.bak.sh
+mv catalina.sh comms/jakarta/tomcat/bin/catalina.sh 
 
 #edit the server config file
-cat comms/tomcat/jakarta/conf/server.xml | sed "s,<\!-- Tomcat Root Context -->,<\!-- GSDL3 Service --><Context path=\"/gsdl3\" docBase=\"$GSDL3HOME/web\" debug=\"1\" reloadable=\"true\"/><\!-- Tomcat Root Context -->," > server.xml
-mv comms/tomcat/jakarta/conf/server.xml comms/tomcat/jakarta/conf/server.bak.xml 
-mv server.xml comms/tomcat/jakarta/conf/server.xml
+cat comms/jakarta/tomcat/conf/server.xml | sed "s,<\!-- Tomcat Root Context -->,<\!-- GSDL3 Service --><Context path=\"/gsdl3\" docBase=\"$GSDL3HOME/web\" debug=\"1\" reloadable=\"true\"/><\!-- Tomcat Root Context -->," > server.xml
+mv comms/jakarta/tomcat/conf/server.xml comms/jakarta/tomcat/conf/server.bak.xml 
+mv server.xml comms/jakarta/tomcat/conf/server.xml
 
 
 #make everyone happy by giving the right permissions to the shell scripts
-chmod a+x comms/tomcat/jakarta/bin/*.sh
+chmod a+x comms/jakarta/tomcat/bin/*.sh
 
 #now do the compiling etc by calling update.bash
Index: /trunk/gsdl3/install-soap.bash
===================================================================
--- /trunk/gsdl3/install-soap.bash	(revision 4847)
+++ /trunk/gsdl3/install-soap.bash	(revision 4848)
@@ -9,7 +9,7 @@
 
 #add the soap context to tomcat config file
-cat comms/tomcat/jakarta/conf/server.xml | sed "s,<\!-- Tomcat Root Context -->,<\!-- SOAP Service --><Context path=\"/soap\" docBase=\"$GSDL3HOME/comms/soap/soap/webapps/soap\" debug=\"1\" reloadable=\"true\"/><\!-- Tomcat Root Context -->," > server.xml
-mv comms/tomcat/jakarta/conf/server.xml comms/tomcat/jakarta/conf/server.bak.xml 
-mv server.xml comms/tomcat/jakarta/conf/server.xml
+cat comms/jakarta/tomcat/conf/server.xml | sed "s,<\!-- Tomcat Root Context -->,<\!-- SOAP Service --><Context path=\"/soap\" docBase=\"$GSDL3HOME/comms/soap/soap/webapps/soap\" debug=\"1\" reloadable=\"true\"/><\!-- Tomcat Root Context -->," > server.xml
+mv comms/jakarta/tomcat/conf/server.xml comms/jakarta/tomcat/conf/server.bak.xml 
+mv server.xml comms/jakarta/tomcat/conf/server.xml
 
 #edit the SOAPServer class
@@ -25,6 +25,6 @@
 
 #deploy the service
-comms/tomcat/jakarta/bin/shutdown.sh
-comms/tomcat/jakarta/bin/startup.sh
+comms/jakarta/tomcat/bin/shutdown.sh
+comms/jakarta/tomcat/bin/startup.sh
 
 # IMPORTANT!!!!!!!!!!!!!!
Index: /trunk/gsdl3/install.bash
===================================================================
--- /trunk/gsdl3/install.bash	(revision 4847)
+++ /trunk/gsdl3/install.bash	(revision 4848)
@@ -30,7 +30,7 @@
 
 # unpack tomcat and create symbolic link
-cd comms/tomcat/
+cd comms/jakarta/
 tar xzf jakarta-tomcat-4.0.1.tar.gz 
-ln -s jakarta-tomcat-4.0.1 jakarta
+ln -s jakarta-tomcat-4.0.1 tomcat
 cd $GSDL3HOME
 
@@ -58,16 +58,16 @@
 
 #edit the catalina script
-cat  comms/tomcat/jakarta-tomcat-4.0.1/bin/catalina.sh | sed 's,CP=\"$CATALINA_HOME/bin/bootstrap.jar\",CP=\"$CLASSPATH:$CATALINA_HOME/bin/bootstrap.jar\",' > catalina.sh
-mv   comms/tomcat/jakarta/bin/catalina.sh comms/tomcat/jakarta/bin/catalina.bak.sh
-mv catalina.sh comms/tomcat/jakarta/bin/catalina.sh 
+cat  comms/jakarta/tomcat/bin/catalina.sh | sed 's,CP=\"$CATALINA_HOME/bin/bootstrap.jar\",CP=\"$CLASSPATH:$CATALINA_HOME/bin/bootstrap.jar\",' > catalina.sh
+mv   comms/jakarta/tomcat/bin/catalina.sh comms/jakarta/tomcat/bin/catalina.bak.sh
+mv catalina.sh comms/jakarta/tomcat/bin/catalina.sh 
 
 #edit the server config file
-cat comms/tomcat/jakarta/conf/server.xml | sed "s,<\!-- Tomcat Root Context -->,<\!-- GSDL3 Service --><Context path=\"/gsdl3\" docBase=\"$GSDL3HOME/web\" debug=\"1\" reloadable=\"true\"/><\!-- Tomcat Root Context -->," > server.xml
-mv comms/tomcat/jakarta/conf/server.xml comms/tomcat/jakarta/conf/server.bak.xml 
-mv server.xml comms/tomcat/jakarta/conf/server.xml
+cat comms/jakarta/tomcat/conf/server.xml | sed "s,<\!-- Tomcat Root Context -->,<\!-- GSDL3 Service --><Context path=\"/gsdl3\" docBase=\"$GSDL3HOME/web\" debug=\"1\" reloadable=\"true\"/><\!-- Tomcat Root Context -->," > server.xml
+mv comms/jakarta/tomcat/conf/server.xml comms/jakarta/tomcat/conf/server.bak.xml 
+mv server.xml comms/jakarta/tomcat/conf/server.xml
 
 
 #make everyone happy by giving the right permissions to the shell scripts
-chmod a+x comms/tomcat/jakarta/bin/*.sh
+chmod a+x comms/jakarta/tomcat/bin/*.sh
 
 #now do the compiling etc by calling update.bash
Index: /trunk/gsdl3/setup.bash
===================================================================
--- /trunk/gsdl3/setup.bash	(revision 4847)
+++ /trunk/gsdl3/setup.bash	(revision 4848)
@@ -40,5 +40,5 @@
   export MANPATH
   
-  CLASSPATH=$GSDL3HOME/resources/java:$GSDL3HOME/src/java:$GSDL3HOME/comms/tomcat/jakarta/common/lib/servlet.jar
+  CLASSPATH=$GSDL3HOME/resources/java:$GSDL3HOME/src/java:$GSDL3HOME/comms/jakarta/tomcat/common/lib/servlet.jar
   for JARFILE in  $GSDL3HOME/lib/java/*; do
     CLASSPATH=$CLASSPATH:$JARFILE
Index: /trunk/gsdl3/setup.bat
===================================================================
--- /trunk/gsdl3/setup.bat	(revision 4847)
+++ /trunk/gsdl3/setup.bat	(revision 4848)
@@ -26,5 +26,5 @@
 set PATH=%PATH%;%GSDL3HOME%\bin;%GSDL3HOME%\bin\script;%GSDL3HOME%\lib
 
-set CATALINA_HOME=%GSDL3HOME%\comms\tomcat\jakarta
+set CATALINA_HOME=%GSDL3HOME%\comms\jakarta\tomcat
 set CATALINA_OPTS="-Djava.util.prefs.syncInterval=2000000 -DGSDL3HOME=%GSDL3HOME% -DGSDLOS=%GSDLOS% -DGSDLHOME= -DPATH=%PATH%"
 
Index: /trunk/gsdl3/update-nocvs.bash
===================================================================
--- /trunk/gsdl3/update-nocvs.bash	(revision 4847)
+++ /trunk/gsdl3/update-nocvs.bash	(revision 4848)
@@ -66,12 +66,12 @@
 
 #start tomcat
-comms/tomcat/jakarta/bin/shutdown.sh
-comms/tomcat/jakarta/bin/startup.sh
+comms/jakarta/tomcat/bin/shutdown.sh
+comms/jakarta/tomcat/bin/startup.sh
 
 #NOTE: if you recompile anything, you need to shutdown and restart tomcat
 #to shutdown:
-#comms/tomcat/jakarta/bin/shutdown.sh
+#comms/jakarta/tomcat/bin/shutdown.sh
 #to startup:
-#comms/tomcat/jakarta/bin/startup.sh
+#comms/jakarta/tomcat/bin/startup.sh
 
 
Index: /trunk/gsdl3/update.bash
===================================================================
--- /trunk/gsdl3/update.bash	(revision 4847)
+++ /trunk/gsdl3/update.bash	(revision 4848)
@@ -66,12 +66,12 @@
 
 #start tomcat
-comms/tomcat/jakarta/bin/shutdown.sh
-comms/tomcat/jakarta/bin/startup.sh
+comms/jakarta/tomcat/bin/shutdown.sh
+comms/jakarta/tomcat/bin/startup.sh
 
 #NOTE: if you recompile anything, you need to shutdown and restart tomcat
 #to shutdown:
-#comms/tomcat/jakarta/bin/shutdown.sh
+#comms/jakarta/tomcat/bin/shutdown.sh
 #to startup:
-#comms/tomcat/jakarta/bin/startup.sh
+#comms/jakarta/tomcat/bin/startup.sh
 
 