Index: /trunk/gsdl3/web/interfaces/default/transform/classifier.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/classifier.xsl	(revision 4865)
+++ /trunk/gsdl3/web/interfaces/default/transform/classifier.xsl	(revision 4866)
@@ -14,5 +14,5 @@
   <xsl:template name="pageHead">
     <head>
-      <title><xsl:value-of select="util:getInterfaceText($interface_name, page/@lang, 'gsdl')"/></title>
+      <title><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'gsdl')"/></title>
     </head>
   </xsl:template>
@@ -55,4 +55,42 @@
   </xsl:template>
   
+<!--
+  <xsl:template match="classifier|classifierNode" mode="process-children">
+    <xsl:param name="collName"/>
+    <xsl:param name="serviceName"/>
+    <xsl:if test="classifierNode|documentNode"> 
+      <table width='100%'>
+	<xsl:for-each select="classifierNode|documentNode">
+	  <tr><xsl:apply-templates select="."/>
+	    <xsl:if test="name()='classifierNode' and @interleave='true'">
+	      <p />
+	      <xsl:apply-templates select="." mode="process-children"/>
+	  </tr>
+	</xsl:for-each>
+      </table>
+      <xsl:if test="@interleave='false' and classifierNode">
+	<table width='100%'>
+	  <xsl:for-each select="classifierNode">
+	    <tr><xsl:apply-templates select="." mode="process-children"/></tr>
+	  </xsl:for-each>
+	</table>
+      </xsl:if>
+    </xsl:if>
+  </xsl:template>
+  -->
+  
+  <!-- default doc node template: icon and title -->
+  <xsl:template match="documentNode">
+    <xsl:param name="collName"/>
+    <td><a href="{$library_name}?a=d&amp;c={$collName}&amp;d={@nodeID}&amp;dt={@documentType}"><xsl:apply-templates select="." mode="displayNodeIcon"/></a></td><td align='left'><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
+  </xsl:template>
+  
+  <!-- default classifier node template: icon + title -->
+  <xsl:template match="classifierNode">
+    <xsl:param name="collName"/>
+    <xsl:param name="serviceName"/>
+    <td><a><xsl:attribute name='href'><xsl:value-of select='$library_name'/>?a=b&amp;rt=r&amp;s=<xsl:value-of select='$serviceName'/>&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@nodeID'/><xsl:if test="classifierNode|documentNode">.pr</xsl:if></xsl:attribute><img src='interfaces/default/images/bshelf.gif' border='0' width='20' height='16' /></a></td><td align='left'><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
+  </xsl:template>
+  
   <!-- recursively process all nodes and documents -->
   
@@ -169,15 +207,15 @@
 
   <!-- default doc node template: icon and title -->
-  <xsl:template match="documentNode">
+<!--  <xsl:template match="documentNode">
     <xsl:param name="collName"/>
     <td><a href="{$library_name}?a=d&amp;c={$collName}&amp;d={@nodeID}&amp;dt={@documentType}"><xsl:apply-templates select="." mode="displayNodeIcon"/></a></td><td><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
-  </xsl:template>
+  </xsl:template>-->
   
   <!-- default classifier node template: icon + title -->
-  <xsl:template match="classifierNode">
+ <!-- <xsl:template match="classifierNode">
     <xsl:param name="collName"/>
     <xsl:param name="serviceName"/>
     <td><a><xsl:attribute name='href'><xsl:value-of select='$library_name'/>?a=b&amp;rt=r&amp;s=<xsl:value-of select='$serviceName'/>&amp;c=<xsl:value-of select='$collName'/>&amp;cl=<xsl:value-of select='@nodeID'/><xsl:if test="classifierNode|documentNode">.pr</xsl:if></xsl:attribute><img src='interfaces/default/images/bshelf.gif' border='0' width='20' height='16' /></a></td><td align='left'><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
-  </xsl:template>
+  </xsl:template>-->
   
   <!-- an alternative classifier node template: the title is a link -->
Index: /trunk/gsdl3/web/interfaces/default/transform/config_format.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/config_format.xsl	(revision 4865)
+++ /trunk/gsdl3/web/interfaces/default/transform/config_format.xsl	(revision 4866)
@@ -57,6 +57,8 @@
   </xsl:template>
 
-  <xsl:template match="gsf:metadata">    
-    <xsl:choose>
+  <xsl:template match="gsf:metadata">
+    <xslt:value-of disable-output-escaping="yes"><xsl:attribute name="select">metadataList/metadata[@name="<xsl:if test="@select='parent'">parent_</xsl:if><xsl:if test="@select='ancestors'">ancestors'<xsl:value-of select='@separator'/>'_</xsl:if><xsl:value-of select="@name"/>"]</xsl:attribute></xslt:value-of>
+  </xsl:template>
+  <!--  <xsl:choose>
       <xsl:when test="@select='parent'">
 	<xslt:value-of><xsl:attribute name="select">parent::node()/metadataList/metadata[@name='<xsl:value-of select="@name"/>']</xsl:attribute></xslt:value-of>
@@ -69,11 +71,11 @@
       </xsl:otherwise>
     </xsl:choose>
+  </xsl:template>-->
+
+  
+  <xsl:template match="gsf:text">
+    <xslt:apply-templates select="nodeContent"/>
   </xsl:template>
-
-<!--
-  <xsl:template match="gsf:text">
-TODO
-  </xsl:template>
--->
+  
   <xsl:template match="*">
     <xsl:copy>
Index: /trunk/gsdl3/web/interfaces/default/transform/querytools.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/querytools.xsl	(revision 4865)
+++ /trunk/gsdl3/web/interfaces/default/transform/querytools.xsl	(revision 4866)
@@ -43,5 +43,5 @@
       </a>
     </td>
-    <td><xsl:value-of select="metadataList/metadata[@name='Title']"/></td>
+    <td><xsl:value-of disable-output-escaping="yes" select="metadataList/metadata[@name='Title']"/></td>
   </xsl:template>
   