Index: /trunk/gsdl3/web/interfaces/default/transform/about.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/about.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/about.xsl	(revision 4900)
@@ -14,5 +14,5 @@
   <xsl:template name="pageHead">
     <head>
-      <title>
+      <title>x
 	<xsl:value-of select="/page/pageRequest/paramList/param[@name='c']/@value"/>
       </title>
Index: /trunk/gsdl3/web/interfaces/default/transform/classifier.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/classifier.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/classifier.xsl	(revision 4900)
@@ -43,11 +43,10 @@
     <table width='537'><tr>
 	<xsl:for-each select="classifier">
-	  <xsl:variable name="cname" select="@name"/>
 	  <xsl:choose>
 	    <xsl:when test="@name=$selected">
-	      <td align='center'><xsl:value-of select="ancestor::service/display/classifier[@name=$cname]/name"/></td>
+	      <td align='center'><xsl:value-of select="displayItem[@name='name']"/></td>
 	    </xsl:when>
 	    <xsl:otherwise>
-	      <td align='center'><a href="{$library_name}?a=b&amp;rt=r&amp;s={$serviceName}&amp;c={$collName}&amp;cl={@name}"><xsl:value-of select="ancestor::service/display/classifier[@name=$cname]/name"/></a></td></xsl:otherwise></xsl:choose>
+	      <td align='center'><a href="{$library_name}?a=b&amp;rt=r&amp;s={$serviceName}&amp;c={$collName}&amp;cl={@name}"><xsl:value-of select="displayItem[@name='name']"/></a></td></xsl:otherwise></xsl:choose>
  	</xsl:for-each>
       </tr></table>
Index: /trunk/gsdl3/web/interfaces/default/transform/classifiertools.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/classifiertools.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/classifiertools.xsl	(revision 4900)
@@ -78,5 +78,5 @@
   <xsl:template match="documentNode">
     <xsl:param name="collName"/>
-    <td><a href="{$library_name}?a=d&amp;c={$collName}&amp;d={@nodeID}&amp;dt={@documentType}"><xsl:apply-templates select="." mode="displayNodeIcon"/></a></td><td align='left'><xsl:value-of disable-output-escaping="yes"  select="metadataList/metadata[@name='Title']"/></td>
+    <td><a href="{$library_name}?a=d&amp;c={$collName}&amp;d={@nodeID}&amp;dt={@docType}"><xsl:apply-templates select="." mode="displayNodeIcon"/></a></td><td align='left'><xsl:value-of disable-output-escaping="yes"  select="metadataList/metadata[@name='Title']"/></td>
   </xsl:template>
   
Index: /trunk/gsdl3/web/interfaces/default/transform/config_format.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/config_format.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/config_format.xsl	(revision 4900)
@@ -39,5 +39,5 @@
       </xsl:when>
       <xsl:otherwise> <!-- a document link -->
-	<a><xslt:attribute name="href"><xslt:value-of select='$library_name'/>?a=d&amp;c=<xslt:value-of select='$collName'/>&amp;d=<xslt:value-of select='@nodeID'/>&amp;dt=<xslt:value-of select='@documentType'/><xslt:if test="@nodeType='leaf'">&amp;sib=1</xslt:if></xslt:attribute><xsl:apply-templates/></a>
+	<a><xslt:attribute name="href"><xslt:value-of select='$library_name'/>?a=d&amp;c=<xslt:value-of select='$collName'/>&amp;d=<xslt:value-of select='@nodeID'/>&amp;dt=<xslt:value-of select='@docType'/><xslt:if test="@nodeType='leaf'">&amp;sib=1</xslt:if></xslt:attribute><xsl:apply-templates/></a>
       </xsl:otherwise>
     </xsl:choose>
Index: /trunk/gsdl3/web/interfaces/default/transform/document.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/document.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/document.xsl	(revision 4900)
@@ -88,10 +88,10 @@
     <xsl:param name="collName"/>
     <xsl:choose>
-      <xsl:when test="@documentType='hierarchy'">
+      <xsl:when test="@docType='hierarchy'">
 	<xsl:call-template name="hierarchicalContents">
 	  <xsl:with-param name="collName" select="$collName"/>
 	</xsl:call-template>
       </xsl:when>
-      <xsl:when test="@documentType='paged'">
+      <xsl:when test="@docType='paged'">
 	<xsl:call-template name="pagedContents">
 	  <xsl:with-param name="collName" select="$collName"/>
@@ -243,5 +243,5 @@
       <table border='1' cellspacing='0'>
 	<tr><td>
-	    <p /><xsl:value-of select="display/name"/><p/>
+	    <p /><xsl:value-of select="displayItem[@name='name']"/><p/>
 	    <form name="EnrichForm" method="get" action="/gsdl3/{$library_name}">
 	      <xsl:apply-templates select="paramList"/>
@@ -252,5 +252,5 @@
 		<input type='hidden' name='sib'><xsl:attribute name='value'><xsl:value-of select='/page/pageRequest/paramList/param[@name="sib"]/@value'/></xsl:attribute></input></xsl:if>
 	      <input type='hidden' name='s' value='{@name}'/>
-	      <input type="submit"><xsl:attribute name="value"><xsl:value-of select='display/submit'/></xsl:attribute></input>
+	      <input type="submit"><xsl:attribute name="value"><xsl:value-of select="displayItem[@name='submit']"/></xsl:attribute></input>
 	    </form>
 	  </td></tr>
@@ -275,6 +275,5 @@
 	  </xsl:when>
 	  <xsl:otherwise>
-	    <xsl:variable name="pname" select="@name"/>
-	    <tr><td><xsl:value-of select='ancestor::service/display/param[@name=$pname]/name'/></td><td align="right"><xsl:apply-templates select="."/></td></tr>
+	    <tr><td><xsl:value-of select="displayItem[@name='name']"/></td><td align="right"><xsl:apply-templates select="."/></td></tr>
 	  </xsl:otherwise>
 	</xsl:choose>
Index: /trunk/gsdl3/web/interfaces/default/transform/process.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/process.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/process.xsl	(revision 4900)
@@ -39,5 +39,5 @@
     <xsl:variable name='action' select="/page/pageRequest/@action"/>
     <xsl:variable name='lang' select="/page/@lang"/>
-    <h3><xsl:value-of select="display/name"/></h3><p/>
+    <h3><xsl:value-of select="displayItem[@name='name']"/></h3><p/>
     <form name="BuildForm" method="get" action="/gsdl3/{$library_name}">
       <xsl:apply-templates select="paramList"/>
@@ -48,5 +48,5 @@
       <input type="hidden" name="s" value="{@name}"/>
       <input type="hidden" name="rt" value="r"/>
-      <input type="submit"><xsl:attribute name="value"><xsl:value-of select='display/submit'/></xsl:attribute></input>
+      <input type="submit"><xsl:attribute name="value"><xsl:value-of select="displayItem[@name='submit']"/></xsl:attribute></input>
     </form>
     <xsl:call-template name="greenBar"/>
Index: /trunk/gsdl3/web/interfaces/default/transform/query.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/query.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/query.xsl	(revision 4900)
@@ -66,5 +66,5 @@
     <xsl:param name="collName"/>
     <xsl:variable name="subaction" select="../pageRequest/@subaction"/>
-    <h3><xsl:value-of select="display/name"/></h3><p/>
+    <h3><xsl:value-of select="displayItem[@name='name']"/></h3><p/>
     <form name="QueryForm" method="get" action="/gsdl3/{$library_name}">
       <input type="hidden" name="a" value="q"/>
@@ -75,5 +75,5 @@
       <input type="hidden" name="hn" value="1"/>
       <xsl:apply-templates select="paramList"/>
-      <input type="submit"><xsl:attribute name="value"><xsl:value-of select='display/submit'/></xsl:attribute></input>
+      <input type="submit"><xsl:attribute name="value"><xsl:value-of select="displayItem[@name='submit']"/></xsl:attribute></input>
     </form>
   </xsl:template>
Index: /trunk/gsdl3/web/interfaces/default/transform/querytools.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/querytools.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/querytools.xsl	(revision 4900)
@@ -38,5 +38,5 @@
     <xsl:param name="collName"/>
     <td>
-      <a><xsl:attribute name="href"><xsl:value-of select='$library_name'/>?a=d&amp;c=<xsl:value-of select='$collName'/>&amp;d=<xsl:value-of select='@nodeID'/><xsl:if test="@nodeType='leaf'">&amp;sib=1</xsl:if>&amp;dt=<xsl:value-of select='@documentType'/></xsl:attribute>
+      <a><xsl:attribute name="href"><xsl:value-of select='$library_name'/>?a=d&amp;c=<xsl:value-of select='$collName'/>&amp;d=<xsl:value-of select='@nodeID'/><xsl:if test="@nodeType='leaf'">&amp;sib=1</xsl:if>&amp;dt=<xsl:value-of select='@docType'/></xsl:attribute>
 	<xsl:apply-templates select="." mode="displayNodeIcon"/>
       </a>
Index: /trunk/gsdl3/web/interfaces/default/transform/service-params.xsl
===================================================================
--- /trunk/gsdl3/web/interfaces/default/transform/service-params.xsl	(revision 4899)
+++ /trunk/gsdl3/web/interfaces/default/transform/service-params.xsl	(revision 4900)
@@ -20,5 +20,5 @@
 	    <xsl:variable name="pname" select="@name"/>
 	    <xsl:variable name="pvalue"><xsl:apply-templates select="." mode="calculate-default"/></xsl:variable>
-	    <tr><td><xsl:value-of select='ancestor::service/display/param[@name=$pname]/name'/></td><td align="right"><xsl:apply-templates select="."><xsl:with-param name="default" select="$pvalue"/></xsl:apply-templates></td></tr>
+	    <tr><td><xsl:value-of select="displayItem[@name='name']"/></td><td align="right"><xsl:apply-templates select="."><xsl:with-param name="default" select="$pvalue"/></xsl:apply-templates></td></tr>
 	  </xsl:otherwise>
 	</xsl:choose>
@@ -36,8 +36,7 @@
     <xsl:param name="default"/>
     <xsl:variable name="pname" select='@name'/>
-    <xsl:variable name='pdisplay' select='ancestor::service/display/param[@name=$pname]'/>
     <select name='{@shortname}'>
-      <option value="0"><xsl:if test="$default='0'"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select='$pdisplay/option[@name="0"]'/></option>
-      <option value="1"><xsl:if test="$default='1'"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select='$pdisplay/option[@name="1"]'/></option>
+      <option value="0"><xsl:if test="$default='0'"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select="option[@name='0']/displayItem[@name='name']"/></option>
+      <option value="1"><xsl:if test="$default='1'"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select="option[@name='1']/displayItem[@name='name']"/></option>
     </select>
   </xsl:template>
@@ -53,8 +52,7 @@
     <xsl:param name="default"/>
     <xsl:variable name="pname"><xsl:value-of select='@name'/></xsl:variable>
-    <xsl:variable name='pdisplay' select='ancestor::service/display/param[@name=$pname]'/>
     <xsl:choose>
       <xsl:when test="count(option) = 1">
-	<xsl:value-of select='$pdisplay/option'/>
+	<xsl:value-of select="option/displayItem[@name='name']"/>
 	<input type='hidden' name='{@shortname}'><xsl:attribute name='value'><xsl:value-of  select='option/@name'/></xsl:attribute></input>
       </xsl:when>
@@ -62,6 +60,5 @@
 	<select name="{@shortname}">
 	  <xsl:for-each select="option">
-	    <xsl:variable name='op_name' select='@name'/>
-	    <option value="{@name}"><xsl:if test="@name=$default"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select='$pdisplay/option[@name=$op_name]'/></option>
+	    <option value="{@name}"><xsl:if test="@name=$default"><xsl:attribute name="selected"></xsl:attribute></xsl:if><xsl:value-of select="displayItem[@name='name']"/></option>
 	  </xsl:for-each>
 	</select>
@@ -75,9 +72,7 @@
   <xsl:template match="param[@type='enum_multi']">
     <xsl:variable name="pname" select='@name'/>
-    <xsl:variable name='pdisplay' select='ancestor::service/display/param[@name=$pname]'/>
     <select name="{@shortname}" size='2'><xsl:attribute name="multiple"></xsl:attribute>
       <xsl:for-each select="option">
-	<xsl:variable name='op_name' select='@name'/>
-	<option value="{@name}"><xsl:value-of select='$pdisplay/option[@name=$op_name]'/></option>
+	<option value="{@name}"><xsl:value-of select="displayItem[@name='name']"/></option>
       </xsl:for-each>
     </select>
@@ -100,10 +95,8 @@
     <xsl:variable name="parent" select="@name"/>
     <table>
-      <tr><td colspan='10'><xsl:value-of select="ancestor::service/display/param[@name=$parent]/name"/></td></tr>
+      <tr><td colspan='10'><xsl:value-of select="displayItem[@name='name']"/></td></tr>
       <tr>
 	<xsl:for-each select="param">
-	  <xsl:variable name='pname' select='@name'/>
-	 
-	  <td><xsl:value-of select="ancestor::service/display/param[@name=$pname]/name"/></td>
+	  <td><xsl:value-of select="displayItem[@name='name']"/></td>
 	</xsl:for-each>
       </tr>
@@ -114,5 +107,5 @@
   <xsl:template match="param[@type='multi']" mode="contents">
     <xsl:param name="occurs">1</xsl:param>
-    <xsl:variable name="pos" select="@occurs - $occurs"/>
+    <xsl:variable name="pos" select="@occurs - $occurs"/>	
     <tr><xsl:for-each select="param">
 	<xsl:variable name="pname" select="@name"/>