Index: trunk/gsdl3/web/interfaces/default/transform/about.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/about.xsl	(revision 4943)
+++ trunk/gsdl3/web/interfaces/default/transform/about.xsl	(revision 4948)
@@ -15,5 +15,5 @@
     <head>
       <title>x
-	<xsl:value-of select="/page/pageRequest/paramList/param[@name='c']/@value"/>
+	<xsl:value-of select="/page/pageResponse/*/displayItem[@name='name']"/>
       </title>
     </head>
@@ -37,4 +37,6 @@
       </xsl:call-template>
     </xsl:if>
+    <p/><h2><xsl:value-of select="displayItem[@name='name']"/></h2>
+    <p/><xsl:value-of select="displayItem[@name='description']"/>
     <p/><xsl:apply-templates select="metadataList">
       <xsl:with-param name="collName" select="$collName"/>
@@ -48,5 +50,5 @@
   <xsl:template match="metadataList">
     <xsl:param name="collName"/>
-    <h2><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about.description')"/></h2>
+    <h2><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about.metadata')"/></h2>
     <p/>
     <table width='537'>
Index: trunk/gsdl3/web/interfaces/default/transform/home.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/home.xsl	(revision 4943)
+++ trunk/gsdl3/web/interfaces/default/transform/home.xsl	(revision 4948)
@@ -37,8 +37,8 @@
 	  <img width="150" border="1">
 	    <xsl:attribute name="src">
-	      <xsl:value-of select="metadataList/metadata[@name='httpPath']"/>/images/<xsl:value-of select="metadataList/metadata[@name='colIcon']"/>
+	      <xsl:value-of select="metadataList/metadata[@name='httpPath']"/>/images/<xsl:value-of select="displayItem[@name='icon']"/>
 	    </xsl:attribute>
 	    <xsl:attribute name="alt">
-	      <xsl:value-of select="metadataList/metadata[@name='colName']"/>
+	      <xsl:value-of select="displayItem[@name='name']"/>
 	    </xsl:attribute>
 	  </img>
Index: trunk/gsdl3/web/interfaces/default/transform/style.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/default/transform/style.xsl	(revision 4943)
+++ trunk/gsdl3/web/interfaces/default/transform/style.xsl	(revision 4948)
@@ -79,5 +79,5 @@
     <xsl:param name="collName"/>
     <xsl:variable name="httpPath" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
-    <xsl:variable name="colIcon" select="/page/pageResponse/collection/metadataList/metadata[@name='colIcon']"/>
+    <xsl:variable name="colIcon" select="/page/pageResponse/collection/displayItem[@name='icon']"/>
     <table width="537">
       <tr>
Index: trunk/gsdl3/web/interfaces/nzdl/transform/about.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/nzdl/transform/about.xsl	(revision 4943)
+++ trunk/gsdl3/web/interfaces/nzdl/transform/about.xsl	(revision 4948)
@@ -13,5 +13,5 @@
   <xsl:template name="pageHead">
     <head>
-      <title><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'nzdl')"/></title>
+      <title><xsl:value-of select="/page/pageResponse/collection/displayItem[@name='name']"/></title>
     </head>
     <xsl:call-template name="headScript"/>
@@ -24,18 +24,5 @@
     </center>
   </xsl:template>
-<!--
-  <xsl:template match="serviceCluster">
-    <xsl:param name="collName"/>
-    <xsl:call-template name="clusterPageBanner">
-      <xsl:with-param name="clusterName" select="$collName"/>
-    </xsl:call-template>
-    <p/><xsl:apply-templates select="metadataList">
-      <xsl:with-param name="collName" select="$collName"/>
-    </xsl:apply-templates>
-    <p/><xsl:apply-templates select="serviceList">
-      <xsl:with-param name="collName" select="$collName"/>
-    </xsl:apply-templates>
-  </xsl:template>
--->
+
   <xsl:template match="collection">
     <xsl:param name="collName"/>
@@ -46,5 +33,5 @@
     <p />
     <h3><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about.aboutcoll')"/></h3>
-    <table><tr><td><xsl:value-of select="metadataList/metadata[@name='colDescription']" disable-output-escaping='yes'/></td></tr></table>
+    <table><tr><td><xsl:value-of select="displayItem[@name='description']" disable-output-escaping='yes'/></td></tr></table>
     <p />
     <h3><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about.howtofind', $collName)"/></h3>
@@ -52,40 +39,4 @@
   </xsl:template>
 
-<!--
-  <xsl:template match="metadataList">
-    <xsl:param name="collName"/>
-    <h2><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about.description')"/></h2>
-    <p/>
-    <table width='537'>
-      <xsl:for-each select="metadata">
-	<tr valign='top'><td><b><xsl:value-of select="@name"/></b></td><td><xsl:value-of select="."/></td></tr>
-      </xsl:for-each>
-    </table>
-  </xsl:template>
--->
-<!--
-  <xsl:template match="serviceList">
-    <xsl:param name="collName"/>
-    <h2><xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about.services')"/></h2>
-    <xsl:if test="count(service) > 0">
-      <table>
-	<xsl:for-each select="service">
-	  <xsl:variable name="action"><xsl:choose>
-	      <xsl:when test="@type='query'">q</xsl:when>
-	      <xsl:when test="@type='browse'">b</xsl:when>
-	      <xsl:when test="@type='process'">pr</xsl:when>
-	      <xsl:when test="@type='applet'">a</xsl:when>
-	      <xsl:otherwise>DO_NOT_DISPLAY</xsl:otherwise>
-	    </xsl:choose></xsl:variable>
-	  <xsl:if test="$action !='DO_NOT_DISPLAY'">
-	    <tr><td><a href="{$library_name}?a={$action}&amp;rt=d&amp;s={@name}&amp;c={$collName}"><xsl:value-of select="@name"/></a></td></tr>
-	  </xsl:if>
-	</xsl:for-each>
-      </table>
-    </xsl:if>
-    <xsl:call-template name="greenBar"/>
-  </xsl:template>
--->
-
 
 </xsl:stylesheet>  
Index: trunk/gsdl3/web/interfaces/nzdl/transform/home.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/nzdl/transform/home.xsl	(revision 4943)
+++ trunk/gsdl3/web/interfaces/nzdl/transform/home.xsl	(revision 4948)
@@ -115,8 +115,8 @@
       <img width="150" border="1">
 	<xsl:attribute name="src">
-	  <xsl:value-of select="metadataList/metadata[@name='httpPath']"/>/images/<xsl:choose><xsl:when test="metadataList/metadata[@name='colIconSmall']"><xsl:value-of select="metadataList/metadata[@name='colIconSmall']"/></xsl:when><xsl:otherwise><xsl:value-of select="metadataList/metadata[@name='colIcon']"/></xsl:otherwise></xsl:choose>
+	  <xsl:value-of select="metadataList/metadata[@name='httpPath']"/>/images/<xsl:choose><xsl:when test="displayItem[@name='smallicon']"><xsl:value-of select="displayItem[@name='smallicon']"/></xsl:when><xsl:otherwise><xsl:value-of select="displayItem[@name='icon']"/></xsl:otherwise></xsl:choose>
 	</xsl:attribute>
 	<xsl:attribute name="alt">
-	  <xsl:value-of select="metadataList/metadata[@name='colName']"/>
+	  <xsl:value-of select="displayItem[@name='name']"/>
 	</xsl:attribute>
       </img>
Index: trunk/gsdl3/web/interfaces/nzdl/transform/style.xsl
===================================================================
--- trunk/gsdl3/web/interfaces/nzdl/transform/style.xsl	(revision 4943)
+++ trunk/gsdl3/web/interfaces/nzdl/transform/style.xsl	(revision 4948)
@@ -85,5 +85,5 @@
     <xsl:param name="pageType"/>
     <xsl:variable name="httpPath" select="/page/pageResponse/collection/metadataList/metadata[@name='httpPath']"/>
-    <xsl:variable name="colIcon" select="/page/pageResponse/collection/metadataList/metadata[@name='colIcon']"/>
+    <xsl:variable name="colIcon" select="/page/pageResponse/collection/displayItem[@name='icon']"/>
     <xsl:variable name="lang" select="/page/@lang"/>
     <table width="537">