Index: trunk/gsdl/macros/thai2.dm
===================================================================
--- trunk/gsdl/macros/thai2.dm	(revision 5064)
+++ trunk/gsdl/macros/thai2.dm	(revision 5064)
@@ -0,0 +1,53 @@
+
+############################################################################
+#
+# This stuff is only used by the usability (I'd like to Complain) stuff
+#
+############################################################################
+package Global
+
+_greenstoneusabilitytext_ [l=th] {àž§àžŽàžàžµàžàž²àž£à¹àžà¹àžàž£àžµàžàžªà¹àžàž}
+
+_textwhy_ [l=th] {<p>àžàž²àž£àžªà¹àžàž£àž²àž¢àžàž²àžàžàžµà¹à¹àžà¹àžàžàž²àžàžàžµà¹àžàžµà¹à¹àž«à¹à¹àž«à¹àžàž§à¹àž²àžàžžàžàžàžàž«àžà¹àž²à¹àž§àžà¹àžàžàžàžµà¹àžàžžàžà¹àžà¹àžàžŽàžàž²àž£àžàž²àžàž¶àžàžàž§àž²àž¡àž¢àž²àžàž«àž£àž·àž­àžàž§àž²àž¡à¹àž¡à¹àž­àžàžàž.}
+_textextraforform_ [l=th] {àžàžžàžà¹àž¡à¹àžà¹àž­àžàžàž£àž­àžà¹àžàžàžàž­àž£à¹àž¡ -- àžà¹àž­àž¡àž¹àž¥à¹àž à¹ àžà¹àžàž²àž¡àžàžµà¹àžàž°àžà¹àž§àž¢}
+_textprivacybasic_ [l=th] {<p>àžàž²àž£àž£àž²àž¢àžàž²àžàžàž°àžàž£àž°àžàž­àžàžàž¶à¹àžà¹àžàžàž²àž°àžà¹àž­àž¡àž¹àž¥àžàžµà¹à¹àžàžµà¹àž¢àž§àžàž±àžà¹àž§àžà¹àžàžàžàž£àžµàžàžªà¹àžàžàžàžžàžàžàžŽàžàž²àž£àžàž², à¹àž¥àž°à¹àžàžà¹àžà¹àž¥àž¢àžµàžàžµà¹àžàžžàžà¹àžà¹àž¡àž±àž (àžàž§àžàžàž±àžàžà¹àž­àž¡àž¹àž¥àžàž±àž§à¹àž¥àž·àž­àžàžàžµà¹àžàžžàžàžàž±àžàž«àž²à¹àž§à¹).}
+_textstillsend_ [l=th] {àžàžžàžàž¢àž±àžàžàžàžà¹àž­àžàžàž²àž£àžªà¹àžàž£àž²àž¢àžàž²àžàžàžµà¹àž«àž£àž·àž­?}
+
+_texterror_ [l=th] {àžàžŽàžàžàž¥àž²àž}
+_textyes_ [l=th] {à¹àžà¹}
+_textno_ [l=th] {à¹àž¡à¹}
+_textclosewindow_ [l=th] {àžàžŽàžàž«àžà¹àž²àžà¹àž²àž}
+_textabout_ [l=th] {à¹àžàžµà¹àž¢àž§àžàž±àž}
+_textprivacy_ [l=th] {àžàž§àž²àž¡àž¥àž±àž}
+_textsend_ [l=th] {àžªà¹àž}
+_textdontsend_ [l=th] {Don\\'t àžªà¹àž}
+_textoptionally_ [l=th] {àžàž±àž§à¹àž¥àž·àž­àž}
+
+_textunderdev_ [l=th] {àžàž²àž£àžàž¹àž£àž²àž¢àž¥àž°à¹àž­àžµàž¢àžàž¡àž²àžà¹àž­àžàžàž°àžªàž²àž¡àž²àž£àžà¹àžà¹àžàž£àž°à¹àž¢àžàžà¹à¹àžà¹à¹àžàžàžžàžàžªàžžàžàžà¹àž²àž¢}
+
+_textviewdetails_ [l=th] {àžàžŽàžàž²àž£àžàž²àž£àž²àž¢àž¥àž°à¹àž­àžµàž¢àžàžàž­àžàž£àž²àž¢àžàž²àž}
+_textmoredetails_ [l=th] {àž£àž²àž¢àž¥àž°à¹àž­àžµàž¢àžà¹àžàžŽà¹àž¡à¹àžàžŽàž¡}
+_texttrackreport_ [l=th] {àžàžŽàžàžàž²àž¡àž£àž²àž¢àžàž²àžàžàžµà¹}
+_textcharacterise_ [l=th] {àžàž±àžàž«àž²àž¡àž±àžàžàž·àž­àž­àž°à¹àž£}
+_textseverity_ [l=th] {àžàž±àžàž«àž²à¹àž¥àž§àž£à¹àž²àž¢àž­àž¢à¹àž²àžà¹àž£}
+
+_textbadrender_ [l=th] {àž«àžà¹àž²àžàž¹à¹àžàž¥àž}
+_textcontenterror_ [l=th] {à¹àžàž·à¹àž­àž«àž²àžàžŽàžàžàž¥àž²àž}
+_textstrangebehaviour_ [l=th] {àžàž€àžàžŽàžàž£àž£àž¡à¹àžàž¥àž}
+_textunexpected_ [l=th] {àžàž²àžàž­àž¢à¹àž²àžàžàžµà¹à¹àž¡à¹àžàž²àžàžàžŽàžà¹àžàžŽàžàžàž¶à¹àž}
+_textfunctionality_ [l=th] {àž¢àž²àžàžàžµà¹àžàž°à¹àžà¹}
+_textother_ [l=th] {àž­àž·à¹àžà¹}
+
+_textcritical_ [l=th] {à¹àžàžµà¹àž¢àž§àžàž±àžàžàž²àž£àž§àžŽàžàž²àž£àžà¹}
+_textmajor_ [l=th] {àžàž±àžàž§àž¥}
+_textmedium_ [l=th] {àžàž¥àž²àž}
+_textminor_ [l=th] {à¹àž¥à¹àžàžà¹àž­àž¢}
+_texttrivial_ [l=th] {àžàž£àž£àž¡àžàž²}
+
+_textwhatdoing_ [l=th] {àžàžžàžàžàž³àž¥àž±àžàžàž¢àž²àž¢àž²àž¡àžàž°àžàž³àž­àž°à¹àž£?}
+_textwhatexpected_ [l=th] {àž­àž°à¹àž£àžàžµà¹àžàžžàžà¹àžàž¢àžàž²àžàž«àž§àž±àžà¹àž«à¹à¹àžàžŽàžàžàž¶à¹àž}
+_textwhathappened_ [l=th] {à¹àžàžŽàžàž­àž°à¹àž£àžàž¶à¹àžàžàž²àž¡àžàž£àžŽàž?}
+
+_cannotfindcgierror_ [l=th] {<h2>àžàž­à¹àžàž©!</h2>Can\\'t àž«àž²à¹àžàž£à¹àžàž£àž¡à¹àžàžŽàžà¹àž§àž­àž£à¹àžªàž³àž«àž£àž±àž "I\\'d àžà¹àž­àžàžàž²àž£àžà¹àž" àžàžžà¹àž¡.}
+
+_textusabbanner_ [l=th] {àžàžàž£àž¹àžà¹àžàžà¹àžàž£àžžàžàž£àžµàžàžªà¹àžàž}